/**
 ******************************************************************************
 *
 * @file       exampleobject1.cpp
 * @author     The OpenPilot Team, http://www.openpilot.org Copyright (C) 2010.
 * @brief      Implementation of the ExampleObject1 object. This file has been 
 *             automatically generated by the UAVObjectGenerator.
 * 
 * @note       Object definition file: exampleobject1.xml. 
 *             This is an automatically generated file.
 *             DO NOT modify manually.
 *
 * @see        The GNU Public License (GPL) Version 3
 *
 *****************************************************************************/
/* 
 * This program is free software; you can redistribute it and/or modify 
 * it under the terms of the GNU General Public License as published by 
 * the Free Software Foundation; either version 3 of the License, or 
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY 
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; if not, write to the Free Software Foundation, Inc., 
 * 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 */
#include "exampleobject1.h"
#include "uavobjectfields.h"

const QString ExampleObject1::NAME = QString("ExampleObject1");

ExampleObject1::ExampleObject1(): UAVDataObject(OBJID, ISSINGLEINST, ISSETTINGS, NAME)
{
    // Create fields
    QList<UAVObjectField*> fields;
    fields.append(new UAVObjectFieldInt8(QString("Field1"), QString("unit1"), 1));
    fields.append(new UAVObjectFieldInt16(QString("Field2"), QString("unit2"), 1));
    fields.append(new UAVObjectFieldInt32(QString("Field3"), QString("unit3"), 1));
    fields.append(new UAVObjectFieldFloat(QString("Field4"), QString("unit4"), 4));
    fields.append(new UAVObjectFieldUInt8(QString("Field5"), QString("unit5"), 1));
    fields.append(new UAVObjectFieldUInt16(QString("Field6"), QString("unit6"), 1));
    fields.append(new UAVObjectFieldUInt32(QString("Field7"), QString("unit7"), 1));
    QStringList Field8EnumOptions;
    Field8EnumOptions.append("Option1");
    Field8EnumOptions.append("Option2");
    fields.append(new UAVObjectFieldEnum(QString("Field8"), QString("unit8"), 1, Field8EnumOptions));

    // Initialize object
    initializeFields(fields, (quint8*)&data, NUMBYTES);
}

UAVObject::Metadata ExampleObject1::getDefaultMetadata()
{
    UAVObject::Metadata metadata;
    metadata.gcsTelemetryAcked = 1;
    metadata.gcsTelemetryUpdateMode = UAVObject::UPDATEMODE_PERIODIC;
    metadata.gcsTelemetryUpdatePeriod = 200;
    metadata.flightTelemetryAcked = 1;
    metadata.flightTelemetryUpdateMode = UAVObject::UPDATEMODE_ONCHANGE;
    metadata.flightTelemetryUpdatePeriod = 0;
    metadata.loggingUpdateMode = UAVObject::UPDATEMODE_NEVER;
    metadata.loggingUpdatePeriod = 0;
    return metadata;
}

ExampleObject1::DataFields ExampleObject1::getData()
{
    QMutexLocker locker(mutex);
    return data;
}

void ExampleObject1::setData(DataFields& data)
{
    QMutexLocker locker(mutex);
    this->data = data;
    emit objectUpdatedAuto(this); // trigger object updated event
    emit objectUpdated(this);
}

UAVDataObject* ExampleObject1::clone(quint32 instID)
{
    ExampleObject1* obj = new ExampleObject1();
    obj->initialize(instID, this->getMetaObject());
    return obj;
}
