/**
 ******************************************************************************
 *
 * @file       exampleobject2.cpp
 * @author     The OpenPilot Team, http://www.openpilot.org Copyright (C) 2010.
 * @brief      Implementation of the ExampleObject2 object. This file has been 
 *             automatically generated by the UAVObjectGenerator.
 * 
 * @note       Object definition file: exampleobject2.xml. 
 *             This is an automatically generated file.
 *             DO NOT modify manually.
 *
 * @see        The GNU Public License (GPL) Version 3
 *
 *****************************************************************************/
/* 
 * This program is free software; you can redistribute it and/or modify 
 * it under the terms of the GNU General Public License as published by 
 * the Free Software Foundation; either version 3 of the License, or 
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY 
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; if not, write to the Free Software Foundation, Inc., 
 * 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 */
#include "exampleobject2.h"
#include "uavobjectfields.h"

const QString ExampleObject2::NAME = QString("ExampleObject2");

ExampleObject2::ExampleObject2(): UAVDataObject(OBJID, ISSINGLEINST, ISSETTINGS, NAME)
{
    // Create fields
    QList<UAVObjectField*> fields;
    fields.append(new UAVObjectFieldInt8(QString("Field1"), QString("unit1"), 1));
    fields.append(new UAVObjectFieldInt16(QString("Field2"), QString("unit2"), 1));
    fields.append(new UAVObjectFieldInt32(QString("Field3"), QString("unit3"), 1));
    fields.append(new UAVObjectFieldFloat(QString("Field4"), QString("unit4"), 4));

    // Initialize object
    initializeFields(fields, (quint8*)&data, NUMBYTES);
}

UAVObject::Metadata ExampleObject2::getDefaultMetadata()
{
    UAVObject::Metadata metadata;
    metadata.gcsTelemetryAcked = 1;
    metadata.gcsTelemetryUpdateMode = UAVObject::UPDATEMODE_ONCHANGE;
    metadata.gcsTelemetryUpdatePeriod = 0;
    metadata.flightTelemetryAcked = 1;
    metadata.flightTelemetryUpdateMode = UAVObject::UPDATEMODE_PERIODIC;
    metadata.flightTelemetryUpdatePeriod = 100;
    metadata.loggingUpdateMode = UAVObject::UPDATEMODE_NEVER;
    metadata.loggingUpdatePeriod = 0;
    return metadata;
}

ExampleObject2::DataFields ExampleObject2::getData()
{
    QMutexLocker locker(mutex);
    return data;
}

void ExampleObject2::setData(DataFields& data)
{
    QMutexLocker locker(mutex);
    this->data = data;
    emit objectUpdatedAuto(this); // trigger object updated event
    emit objectUpdated(this);
}

UAVDataObject* ExampleObject2::clone(quint32 instID)
{
    ExampleObject2* obj = new ExampleObject2();
    obj->initialize(instID, this->getMetaObject());
    return obj;
}
